<?php
/* vim: set fileencoding=cp932 ai et ts=4 sw=4 sts=0 fdm=marker: */
/* mi: charset=Shift_JIS */

require_once './conf/conf_hostcheck.php';

/**
 * アクセス元ホストをチェックするクラス
 * staticメソッドで利用する
 */
class HostCheck
{
    /**
     * アクセス禁止のメッセージを表示して、PHPの実行を終了する
     *
     * @return  void
     * @access  public
     * @static
     */
    function forbidden()
    {
        header('HTTP/1.0 403 Forbidden');
        ?>
<html>
<head>
    <title>403 Forbidden</title>
</head>
<body>
<h1>p2 info: アクセス禁止</h1>
<p>IP <?php echo $_SERVER['REMOTE_ADDR']; ?> からのアクセスは許可されていません。<br>
もしあなたがこのp2の設置者であれば、conf/conf_hostcheck.php の設定を見直してください。</p>
</body>
</html>
<?php
        exit;
    }


    /**
     * ip2long() の PHP4 と PHP5 での差異を吸収する
     *
     * @param   string  $ip
     * @return  int|bool
     * @access  private
     * @static
     */
    function ip2long($ip)
    {
        $long = ip2long($ip);
        if ($long === -1 && $ip !== '255.255.255.255') {
            return false;
        }
        return $long;
    }


    /**
     * ローカルキャッシュつきgethostbyaddr()
     *
     * @return  string
     * @access  public
     * @static
     */
    function cachedGetHostByAddr($remote_addr)
    {
        global $_conf;

        $function = 'gethostbyaddr';
        $cache_file = $_conf['cache_dir'] . '/hostcheck_gethostbyaddr.cache';

        return HostCheck::_cachedGetHost($remote_addr, $function, $cache_file);
    }


    /**
     * ローカルキャッシュつきgethostbyname()
     *
     * @return  string
     * @access  private
     * @static
     */
    function cachedGetHostByName($remote_host)
    {
        global $_conf;

        $function = 'gethostbyname';
        $cache_file = $_conf['cache_dir'] . '/hostcheck_gethostbyname.cache';

        return HostCheck::_cachedGetHost($remote_host, $function, $cache_file);
    }


    /**
     * cachedGetHostByAddr/cachedGetHostByName のキャッシュエンジン
     *
     * @return  string
     * @access  private
     * @static
     */
    function _cachedGetHost($remote, $function, $cache_file)
    {
        static $caches_ = array();
        
        if (array_key_exists("$function/$remote", $caches_)) {
            return $caches_["$function/$remote"];
        }
        
        $ttl = $GLOBALS['_HOSTCHKCONF']['gethostby_expires'];

        // クライアントホストの名前解決はできるだけ避けるようにする
        if ($function == 'gethostbyaddr' and HostCheck::isAddrLocal() || HostCheck::isAddrPrivate()) {
            $caches_["$function/$remote"] = '';
            return $caches_["$function/$remote"];
        }
        
        // ファイルキャッシュしない設定のとき
        if ($ttl <= 0) {
            $caches_["$function/$remote"] = $function($remote);
            return $caches_["$function/$remote"];
        }

        // ファイルキャッシュ有効のとき
        $now  = time();
        $list = array();

        // キャッシュファイルが無ければ作成する
        if (!file_exists($cache_file)) {
            FileCtl::make_datafile($cache_file);
        }

        // キャッシュを読み込む
        $lines = file($cache_file);
        if (is_array($lines)) {
            foreach ($lines as $line) {
                list($query, $result, $expires) = explode("\t", rtrim($line, "\n"));
                if ($expires > $now) {
                    $list[$query] = array($result, $expires);
                }
            }
        }

        // キャッシュされているとき
        if (isset($list[$remote])) {
            $caches_["$function/$remote"] = $list[$remote][0];
            return $caches_["$function/$remote"];
        }

        // キャッシュされていないとき

        $result = $function($remote);
        
        $list[$remote] = array($result, $ttl + $now);

        // キャッシュを保存する
        $content = '';
        foreach ($list as $query => $item) {
            $content .= $query . "\t" . $item[0] . "\t" . $item[1] . "\n";
        }
        FileCtl::filePutRename($cache_file, $content);

        $caches_["$function/$remote"] = $result;
        return $caches_["$function/$remote"];
    }


    /**
     * アクセスが許可されたIPアドレス帯域なら true を返す
     * (false = アク禁)
     *
     * @return  boolean
     * @access  public
     * @static
     */
    function getHostAuth()
    {
        global $_conf, $_HOSTCHKCONF;

        switch ($_conf['secure']['auth_host']) {
            case 1:
                $flag = 1;
                $ret  = true;
                $custom = $_HOSTCHKCONF['custom_allowed_ips'];
                break;
            case 2:
                $flag = 0;
                $ret  = false;
                $custom = $_HOSTCHKCONF['custom_denied_ips'];
                break;
            default:
                return true;
        }

        if (
            ( $flag == $_HOSTCHKCONF['host_type']['localhost']   && HostCheck::isAddrLocal() ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['private']  && HostCheck::isAddrPrivate() ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['custom']   && $custom && HostCheck::isAddrInBand($custom) ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['docomo']   && HostCheck::isAddrDocomo() ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['au']       && HostCheck::isAddrAu() ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['SoftBank'] && (HostCheck::isAddrSoftBank() || HostCheck::isAddrSoftBankPcSiteBrowser()) ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['AirH']     && HostCheck::isAddrWillcom() ) 
            || ( $flag == $_HOSTCHKCONF['host_type']['iPhone']   && HostCheck::isAddrIPhone() )
        ) {
            return $ret;
        }
        return !$ret;
    }


    /**
     * BBQに焼かれているIPアドレスなら true を返す
     * (true = アク禁)
     *
     * @return  boolean
     * @access  public
     * @static
     */
    function getHostBurned()
    {
        global $_conf;

        if (!$_conf['secure']['auth_bbq'] || HostCheck::isAddrLocal() || HostCheck::isAddrPrivate()) {
            return false;
        }

        if (HostCheck::isAddrBurned()) {
            return true;
        }

        return false;
    }


    /**
     * マスク長をサブネットマスクに変換する
     *
     * @return  string
     * @access  private
     * @static
     */
    function length2subnet($length)
    {
        $subnet = array();
        for ($i = 0; $i < 4; $i++) {
            if ($length >= 8) {
                $subnet[] = '255';
            } elseif ($length > 0) {
                $subnet[] = strval(255 & ~bindec(str_repeat('1', 8 - $length)));
            } else {
                $subnet[] = '0';
            }
            $length -= 8;
        }
        return implode('.', $subnet);
    }


    /**
     * IPは ローカルホスト?
     *
     * @return  boolean
     * @access  private
     * @static
     */
    function isAddrLocal()
    {
        return ($_SERVER['REMOTE_ADDR'] == '127.0.0.1');
    }

    /**
     * IPがBBQチェック対象外かどうか
     *
     * @static
     * @access  public
     * @return  boolean
     */
    function isAddrBurnedNoCheck($addr = null)
    {
        if (
            HostCheck::isAddrDocomo($addr) 
            || HostCheck::isAddrAu($addr) 
            || HostCheck::isAddrSoftBank($addr) 
            || HostCheck::isAddrJig($addr) 
            || HostCheck::isAddrIbis($addr)
        ) {
            return true;
        }
        return false;
    }

    /**
     * ホストがBBQに焼かれているか?
     *
     * @link  http://bbq.uso800.net/code.html
     * @return  boolean  焼かれていたらtrueを返す
     * @access  public
     * @static
     */
    function isAddrBurned($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        $ip_regex = '/^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)$/';
        $errmsg = "\n<br><b>NOTICE: Wrong IP Address given.</b> ($addr)<br>\n";

        // IPアドレスを検証
        if (!preg_match($ip_regex, $addr, $ipv4)) {
            trigger_error($errmsg, E_USER_NOTICE);
            return false; // IPアドレスの書式に合致しない
        }

        // 問い合わせるホスト名を設定
        $query_host = 'niku.2ch.net';
        for ($i = 1; $i <= 4; $i++) {
            $octet = $ipv4[$i];
            if ($octet > 255) {
                trigger_error($errmsg, E_USER_NOTICE);
                return false; // IPアドレスの書式に合致しない
            }
            $query_host = $octet . '.' . $query_host;
        }

        // 問い合わせを実行
        $result_addr = HostCheck::cachedGetHostByName($query_host);

        if ($result_addr == '127.0.0.2') {
            return true; // BBQに焼かれている
        }
        return false; // BBQに焼かれていない or チェック失敗
    }


    /**
     * 任意のIPアドレス帯域内からのアクセスか?
     *
     * 引数の数により処理内容が変わる
     * 1. $_SERVER['REMOTE_ADDR']が第一引数の帯域にあるかチェックする
     * 2. 第一引数が第二引数の帯域にあるかチェックする
     * 3. (2)に加えて第三引数とリモートホストを正規表現マッチングする
     *
     * （2007/08/05 aki 引数の数で処理内容を変えるのではなく、
     * 　単に、$addr と $band の順番を入れ替えた方がわかりやすいような気がしたがどうでしょうどうでしょう(>rskさん)）
     *
     * 帯域指定は以下のいずれかの方式を利用できる (2,3の混在も可)
     * 1. IPアドレス(+スラッシュで区切ってマスク長もしくはサブネットマスク)の文字列
     * 2. (1)の配列
     * 3. IPアドレスをキーとし、マスク長もしくはサブネットマスクを値にとる連想配列
     *
     * @return  boolean
     * @access  private
     * @static
     */
    function isAddrInBand($addr, $band = null, $regexHost = null)
    {
        if (is_null($band)) {
            $regexHost = null;
            $band = $addr;
            $addr = $_SERVER['REMOTE_ADDR'];
        }

        // IPアドレスを検証
        if (($addrlong = HostCheck::ip2long($addr)) === false) {
            return false;
        }

        // IPアドレスを検証
        if (!is_array($band)) {
            $band = array($band);
        }
        foreach ($band as $target => $mask) {
            if (is_int($target) && is_string($mask)) {
                $cond = explode('/', $mask);
                $target = $cond[0];
                $mask = isset($cond[1]) ? (is_numeric($cond[1]) ? intval($cond[1]) : $cond[1]) : '255.255.255.255';
            }
            if (($target = HostCheck::ip2long($target)) === false) {
                continue;
            }
            if (is_int($mask)) {
                $mask = HostCheck::length2subnet($mask);
            }
            if (($mask = HostCheck::ip2long($mask)) === false) {
                continue;
            }
            if (($addrlong & $mask) == ($target & $mask)) {
                return true;
            }
        }

        /*
        // ホストでの判別はやめておく
        
        // 帯域がマッチせず、正規表現が指定されているとき
        if ($regexHost) {
            if ($addr == $_SERVER['REMOTE_ADDR'] && isset($_SERVER['REMOTE_HOST'])) {
                $remote_host = $_SERVER['REMOTE_HOST'];
            } else {
                $remote_host = HostCheck::cachedGetHostByAddr($addr);
            }
            if (preg_match($regexHost, $remote_host)) {
                return true;
            }
        }
        */
        
        return false;
    }

    /**
     * IPは プライベートアドレス?
     *
     * @see RFC1918
     * @return  boolean
     * @access  private
     * @static
     */
    function isAddrPrivate($addr = '', $class = '')
    {
        if (!$addr) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        $class = ($class) ? strtoupper($class) : 'ABC';
        $private = array();
        if (strpos($class, 'A') !== false) {
            $private[] = '10.0.0.0/8';
        }
        if (strpos($class, 'B') !== false) {
            $private[] = '172.16.0.0/12';
        }
        if (strpos($class, 'C') !== false) {
            $private[] = '192.168.0.0/16';
        }
        return HostCheck::isAddrInBand($addr, $private);
    }

    /**
     * IPは docomo?
     *
     * @link  http://www.nttdocomo.co.jp/service/developer/make/content/ip/#ip
     * @return  boolean
     * @access  public
     * @static
     */
    function isAddrDocomo($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }

        $regHost = '/^proxy[0-9a-f]\d\d\.docomo\.ne\.jp$/';
        
        // @updated 2011/05/31
        $bands = array(
           '210.153.84.0/24',
           '210.136.161.0/24',
           '210.153.86.0/24',
           '124.146.174.0/24',
           '124.146.175.0/24',
           '202.229.176.0/24',
           '202.229.177.0/24',
           '202.229.178.0/24',
           
           '210.153.87.0/24' // WEBアクセス時（フルブラウザ）
        );
        return HostCheck::isAddrInBand($addr, $bands, $regHost);
    }

    /**
     * IPは au?
     * 2010/6/6 PCSVの帯域も別途公開されているが、PCSVではHTTP_X_UP_SUBNOが送信されてこないらしい。
     *
     * @link http://www.au.kddi.com/ezfactory/tec/spec/ezsava_ip.html
     * @return  boolean
     * @access  public
     * @static
     */
    function isAddrAu($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }

        //$regHost = '/^wb\d+proxy\d\d\.ezweb\.ne\.jp$/';
        $regHost = '/\.ezweb\.ne\.jp$/';
        
        // @updated 2013/12/01
        $bands = array(
           // EZ兼PCSV。統一されたってことはPCSVもHTTP_X_UP_SUBNOを送信するんだろうか？
            '111.107.116.64/26',
            '106.162.214.160/29',
            '111.107.116.192/28',
            
            // EZ
            '210.230.128.224/28',
            '219.108.158.0/27',
            '219.125.146.0/28',
            '61.117.2.32/29',
            '61.117.2.40/29',
            '219.108.158.40/29',
            '111.86.142.0/26',
            '111.86.141.64/26',
            '111.86.141.128/26',
            '111.86.141.192/26',
            '111.86.143.192/27',
            '111.86.143.224/27',
            '111.86.147.0/27',
            '111.86.142.128/27',
            '111.86.142.160/27',
            '111.86.142.192/27',
            '111.86.142.224/27',
            '111.86.143.0/27',
            '111.86.143.32/27',
            '111.86.147.32/27',
            '111.86.147.64/27',
            '111.86.147.96/27',
            '111.86.147.128/27',
            '111.86.147.160/27',
            '111.86.147.192/27',
            '111.86.147.224/27'
           
           // PCSVは含めず
        );
        return HostCheck::isAddrInBand($addr, $bands, $regHost);
    }
    
    /**
     * IPは SoftBank?
     *
     * @link http://creation.mb.softbank.jp/web/web_ip.html
     * @link http://qb5.2ch.net/test/read.cgi/operate/1116860379/100-125
     * @return  boolean
     * @access  public
     * @static
     */
    function isAddrSoftBank($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }

        // 2007/11/09 .jp-k.ne.jp/.jp-c.ne.jp/.jp-t.ne.jp/.jp-q.ne.jp/.softbank.ne.jp
        $regHost = '/\.(jp-[kctq]|\.softbank)\.ne\.jp$/';
        
        // 2012/10/21
        $bands = array(
            // 2012年5月中旬以降
            '123.108.237.112/28',
            '123.108.239.224/28',
            '202.253.96.144/28',
            '202.253.99.144/28',
            '210.228.189.188/30'
            
            // pcsitebrowserは含まない
        );
        return HostCheck::isAddrInBand($addr, $bands, $regHost);
    }
    
    /**
     * IPは SoftBankのpcsitebrowser?
     *
     * @link http://creation.mb.softbank.jp/web/web_ip.html
     * @link http://qb5.2ch.net/test/read.cgi/operate/1116860379/100-125
     * @return  boolean
     * @access  public
     * @static
     */
    function isAddrSoftBankPcSiteBrowser($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }

        // ml7ts005v11c.pcsitebrowser.ne.jp
        $regHost = '/\.(pcsitebrowser)\.ne\.jp$/';
        
        // 
        $bands = array(
            // PCサイトブラウザ（mobile_ip_diff.plでは拾ってこない）
            // 2012年5月中旬以降
            '123.108.237.128/28',
            '123.108.239.240/28',
            '202.253.96.160/28',
            '202.253.99.160/28',
            '210.228.189.196/30'
        );
        return HostCheck::isAddrInBand($addr, $bands, $regHost);
    }
    
    /**
     * IPは iPhone?
     *
     * @return  boolean
     * @access  public
     * @static
     */
    function isAddrIPhone($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }

        $regHost = null;
        //$regHost = '/\.panda-world\.ne\.jp$/';
        
        // 公式発表データではない
        // @updated 2011/10/15
        $bands = array(
            '126.95.0.0/16',
            '126.140.0.0/16',
            '126.141.0.0/16',
            '126.142.0.0/16',
            '126.143.0.0/16',
            '126.144.0.0/16',
            '126.145.0.0/16',
            '126.146.0.0/16',
            '126.147.0.0/16',
            '126.148.0.0/16',
            '126.149.0.0/16',
            '126.150.0.0/16',
            '126.151.0.0/16',
            '126.152.0.0/16',
            '126.153.0.0/16',
            '126.154.0.0/15',
            '126.156.0.0/14',
            '126.160.0.0/12',
            '126.176.0.0/12',
            '126.195.0.0/16',
            '126.196.0.0/14',
            '126.200.0.0/13',
            '126.208.0.0/13',
            '126.216.0.0/13',
            '126.224.0.0/11'
        );
        return HostCheck::isAddrInBand($addr, $bands, $regHost);
    }
    
    /**
     * IPは WILLCOM?
     *
     * @link http://www.willcom-inc.com/ja/service/contents_service/club_air_edge/for_phone/ip/index.html
     * @return  boolean
     * @access  public
     * @static
     */
    function isAddrWillcom($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        
        $regHost = '/^[Pp]\d{12}\.ppp\.prin\.ne\.jp$/';
        
        // @updated 2013/12/01
        $bands = array(
            '114.20.49.0/24',
            '114.20.50.0/24',
            '114.20.51.0/24',
            '114.20.52.0/24',
            '114.20.53.0/24',
            '114.20.54.0/24',
            '114.20.55.0/24',
            '114.20.56.0/24',
            '114.20.57.0/24',
            '114.20.58.0/24',
            '114.20.59.0/24',
            '114.20.60.0/24',
            '114.20.61.0/24',
            '114.20.62.0/24',
            '114.20.63.0/24',
            '114.20.64.0/24',
            '114.20.65.0/24',
            '114.20.66.0/24',
            '114.20.67.0/24',
            '114.20.128.0/17',
            '114.21.128.0/24',
            '114.21.129.0/24',
            '114.21.130.0/24',
            '114.21.131.0/24',
            '114.21.132.0/24',
            '114.21.133.0/24',
            '114.21.134.0/24',
            '114.21.135.0/24',
            '114.21.136.0/24',
            '114.21.137.0/24',
            '114.21.138.0/24',
            '114.21.139.0/24',
            '114.21.140.0/24',
            '114.21.141.0/24',
            '114.21.142.0/24',
            '114.21.143.0/24',
            '114.21.144.0/24',
            '114.21.145.0/24',
            '114.21.146.0/24',
            '114.21.147.0/24',
            '114.21.148.0/24',
            '114.21.149.0/24',
            '221.109.128.0/18'
        );
        return HostCheck::isAddrInBand($addr, $bands, $regHost);
    }
    
    /**
     * IPは jig web?
     *
     * @static
     * @access  public
     * @return  boolean
     */
    function isAddrJigWeb($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        // bw5022.jig.jp
        $reghost = '/^bw\d+\.jig\.jp$/';
        
        $bands = array(
            '202.181.98.241',   // 2007/08/06
            //'210.143.108.0/24', // 2005/6/23
        );
        return HostCheck::isAddrInBand($addr, $bands, $reghost);
    }
    
    /**
     * IPは jigアプリ?
     *
     * @link    http://br.jig.jp/pc/ip_br.html
     * @static
     * @access  public
     * @return  boolean
     */
    function isAddrJig($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        
        // br***.jig.jp
        $reghost = '/^br\d+\.jig\.jp$/';
        
        // @updated 2010/10/31
        $bands = array(
            '59.106.23.169/32',
            '59.106.23.170/31',
            '59.106.23.172/31',
            '82.48.6.10/31',
            '82.48.6.12/30',
            '112.78.114.208/32',
            '112.78.207.6/31',
            '112.78.207.8/29',
            '112.78.207.16/29',
            '112.78.207.24/31',
            '112.78.207.38/31',
            '112.78.207.40/29',
            '112.78.207.48/29',
            '112.78.207.56/31',
            '112.78.215.70/31',
            '112.78.215.72/29',
            '112.78.215.80/29',
            '112.78.215.88/31',
            '112.78.215.166/31',
            '112.78.215.168/29',
            '112.78.215.176/29',
            '112.78.215.184/31',
            '112.78.215.198/31',
            '112.78.215.200/29',
            '112.78.215.208/29',
            '112.78.215.216/31',
            '112.78.215.230/31',
            '112.78.215.232/29',
            '112.78.215.240/29',
            '112.78.215.248/31',
            '182.48.5.134/31',
            '182.48.5.136/29',
            '182.48.5.144/29',
            '182.48.5.152/31',
            '182.48.5.166/31',
            '182.48.5.168/29',
            '182.48.5.176/29',
            '182.48.5.184/31',
            '182.48.5.198/31',
            '182.48.5.200/29',
            '182.48.5.208/29',
            '182.48.5.216/31',
            '182.48.5.230/31',
            '182.48.5.232/29',
            '182.48.6.6/31',
            '182.48.6.8/29',
            '202.181.98.160/32',
            '202.181.98.179/32',
            '202.181.98.196/32',
            '210.188.205.81/32',
            '210.188.205.83/32',
            '219.94.177.6/31',
            '219.94.177.8/29',
            '219.94.177.16/29',
            '219.94.177.24/31',
            '219.94.182.230/31',
            '219.94.182.232/29',
            '219.94.182.240/29',
            '219.94.182.248/31',
            '219.94.183.102/31',
            '219.94.183.104/29',
            '219.94.183.112/29',
            '219.94.183.120/31',
            '219.94.184.70/31',
            '219.94.184.72/30',
            '219.94.184.76/32'
        );
        return HostCheck::isAddrInBand($addr, $bands, $reghost);
    }
    
    /**
     * IPは ibis?
     *
     * @static
     * @access  public
     * @return  boolean
     */
    function isAddrIbis($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        
        // http://qb5.2ch.net/test/read.cgi/operate/1183341095/504
        // http://ibis.ne.jp/support/browserIP.jsp
        $bands = array(
            //'219.117.203.9', // システム移行が完了すれば利用しなくなるらしい
            //'59.106.52.16/29',
            '59.106.88.0/24'
        );
        return HostCheck::isAddrInBand($addr, $bands);
    }

    /**
     * IPは emobile.ad.jp?
     * http://qb5.2ch.net/test/read.cgi/operate/1247654838/399
     *
     * @static
     * @access  public
     * @return  boolean
     */
    function isAddrEmobileAdJp($addr = null)
    {
        if (is_null($addr)) {
            $addr = $_SERVER['REMOTE_ADDR'];
        }
        
        // http://qb5.2ch.net/test/read.cgi/operate/1235553306/974
        // http://developer.emnet.ne.jp/ipaddress.html
        $bands = array(
            '60.254.209.99/32', // EMnet プロキシなし http://takagi-hiromitsu.jp/diary/20080722.html
            '117.55.1.224/27'
        );
        return HostCheck::isAddrInBand($addr, $bands);
    }
}

/*
 * Local Variables:
 * mode: php
 * coding: cp932
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
// vim: set syn=php fenc=cp932 ai et ts=4 sw=4 sts=4 fdm=marker:
